package main

import (
	"log"
	"net"
	"tgmail/server"
)

func main() {
	l, err := net.Listen("tcp", "0.0.0.0:2525")
	if err != nil {
		panic(err)
	}
	defer l.Close()

	log.Println("Listening!")

	for {
		c, err := l.Accept()
		if err != nil {
			log.Println(err)
			return
		}
		go server.Handle(c)
	}
}
